/*
 *   senator - ASF video stream server
 *   Copyright (C) 2002  anonymous author
 *
 *
 *  senator is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  Senator is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *	
 *  You should have received a copy of the GNU General Public License
 *  along with senator; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 *
 */
    
#include "CLog.h"
#include "stdio.h"

CLog	*logger;

CLog::CLog(const std::string &fileName){
	this->_logFile 		= fileName;
	this->_logStarted 	= false;
	this->_outputToConsole	= false;
}

void CLog::start(){
	if (logStarted()) return;
	_logStarted = true;

	logInfo("server started (log begins)");
}

void CLog::stop(){
	if (!logStarted()) return;
	_logStarted = false;

	logInfo("server stoped (log ends)");
}

bool CLog::logStarted(){
	return _logStarted;
}

// this is always writting to a log file
void CLog::logInfo(const std::string &text){
	// Output to the log file
	if (this->_outputToConsole)
		cout << text.c_str() << endl;

	ofstream of(_logFile.c_str(), ios::out|ios::app);
	if (!of.is_open()) return;

	// Get the time

	time_t	t = time(NULL);
	std::string	ts = asctime(localtime(&t));
	ts[ts.length() - 1] = 0;

	of << ts.c_str() << " - " << text.c_str() <<  endl;
}

// logging interface for verbose output, this is not writting to a log file
void CLog::logText(const std::string &text){
    if (this->_outputToConsole)
	cout << text.c_str() << endl;
}


// always output to console and to log file
void CLog::logError(const std::string &text){
	cout << text.c_str() << endl;

	ofstream of(_logFile.c_str(), ios::out|ios::app);
	if (!of.is_open()) return;

	logInfo(text);
}

void CLog::outputToConsole(bool status){
	this->_outputToConsole = status;
}
